@---------------------------------------------------------------------------------------------------------------------------------------@
@----------------------------------------- MODEL A -----------------------------------------------------------------------------@
@-----------------------Y(t)=alpha+rho*Y(t-lag)+eps(t) ----------------------------------------------------------------@
@----------------------------------------------------------------------------------------------------------------------------------------@

ts=hsec; screen on;


stepn=1;
do while stepn le 5;

@ number of observations @
if stepn==1;n=25; ?"n" n; print;
elseif stepn==2; n=50; ?"n" n;  print;
elseif stepn==3; n=100;?"n" n; print;
elseif stepn==4; n=250;?"n" n; print;
elseif stepn==5; n=500;?"n" n; print;
endif;




@ five different simulations for each n@
iter=1;
do while iter <= 5;
seed1=iter;

@ set up the simulation @
lag=12; @ number of lags @
n1=n-lag;  
nsim=50000; @ number of iterations @

@-------------------------------------------------------------------------------------------------------------------------------------------------@
@ The simulation starts @
series1=zeros(nsim,1);
series2=zeros(nsim,1);

j=1;
do while j <= nsim;

@ generating data @
res=rndns(n,1,seed1);
yz=zeros(n,1);
k=lag+1; do while k <=n; yz[k]=yz[k-lag]+res[k]; k=k+1; endo;
y=yz[lag+1:n];
ylag=yz[1:n1];
x=ones(n1,1)~ylag;


@ calculating least square coefficients @
xxx=inv(x'*x);
theta=xxx*x'*y;

/*
@ M matrix @
m=eye(n1)-x*xxx*x';
*/

@ squared sum of residuals @
/* ser2=y'*m*y/(n-lag-2); */
 ser2=y'y/(n-lag-2)-y'x*xxx*x'*y/(n-lag-2); @ use this line for large n to avoid 
"insufficient workspace memory messages" - the funny thing is that it is also about 5
times faster...@

@ t-statistic of alpha @
talpha=theta[1,1]/((xxx[1,1]*ser2)^.5); 
series1[j,.]=talpha;

sig02=(y-ylag)'*(y-ylag)/n1;

@ Phi1...F-distribution asympt., LR test, H0: (alpha,rho) =(0,1) @
phi1=(n1*sig02-(n-lag-2)*ser2)/(2*ser2);
series2[j,.]=phi1;

j=j+1; endo;
@ the simulation ends @

@-------------------------------------------------------------------------------------------------------------------------------------------------@

/*
@ saving the series @
screen off;
output file=c:\research\df\\modela\results\t.out reset; output on; series1; output off;
output file=c:\research\df\modela\results\p.out reset; output on; series2; output off;
screen on;
*/

@ saving critical values @

cv1=nsim*.01;cv2=nsim*.025;cv3=nsim*.05;cv4=nsim*.1;
cv5=nsim*.9;cv6=nsim*.95;cv7=nsim*.975;cv8=nsim*.99;

series1=sortc(series1,1);

@---------------------------------------------------------------------------------------------------------------------------------------@
if stepn==1;

if iter==1; output file=c:\research\df\modela\results\tc.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\t2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\t3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\t4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\t5c.out reset; output on; 
endif;

series1[cv1,1]~series1[cv2,1]~series1[cv3,1]~series1[cv4,1];
series1[cv5,1]~series1[cv6,1]~series1[cv7,1]~series1[cv8,1];

output off;

series2=sortc(series2,1);

if iter==1; output file=c:\research\df\modela\results\p1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\p2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\p3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\p4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\p5c.out reset; output on; 
endif;

series2[cv1,1]~series2[cv2,1]~series2[cv3,1]~series2[cv4,1];
series2[cv5,1]~series2[cv6,1]~series2[cv7,1]~series2[cv8,1];

output off;

@---------------------------------------------------------------------------------------------------------------------------------------@
elseif stepn==2;

if iter==1; output file=c:\research\df\modela\results\t1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\t2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\t3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\t4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\t5c.out reset; output on; 
endif;

series1[cv1,1]~series1[cv2,1]~series1[cv3,1]~series1[cv4,1];
series1[cv5,1]~series1[cv6,1]~series1[cv7,1]~series1[cv8,1];

output off;

series2=sortc(series2,1);

if iter==1; output file=c:\research\df\modela\results\p1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\p2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\p3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\p4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\p5c.out reset; output on; 
endif;

series2[cv1,1]~series2[cv2,1]~series2[cv3,1]~series2[cv4,1];
series2[cv5,1]~series2[cv6,1]~series2[cv7,1]~series2[cv8,1];

output off;

@---------------------------------------------------------------------------------------------------------------------------------------@
elseif stepn==3;

if iter==1; output file=c:\research\df\modela\results\t1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\t2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\t3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\t4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\t5c.out reset; output on; 
endif;

series1[cv1,1]~series1[cv2,1]~series1[cv3,1]~series1[cv4,1];
series1[cv5,1]~series1[cv6,1]~series1[cv7,1]~series1[cv8,1];

output off;

series2=sortc(series2,1);

if iter==1; output file=c:\research\df\modela\results\p1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\p2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\p3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\p4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\p5c.out reset; output on; 
endif;

series2[cv1,1]~series2[cv2,1]~series2[cv3,1]~series2[cv4,1];
series2[cv5,1]~series2[cv6,1]~series2[cv7,1]~series2[cv8,1];

output off;

@---------------------------------------------------------------------------------------------------------------------------------------@
elseif stepn==4;

if iter==1; output file=c:\research\df\modela\results\t1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\t2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\t3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\t4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\t5c.out reset; output on; 
endif;

series1[cv1,1]~series1[cv2,1]~series1[cv3,1]~series1[cv4,1];
series1[cv5,1]~series1[cv6,1]~series1[cv7,1]~series1[cv8,1];

output off;

series2=sortc(series2,1);

if iter==1; output file=c:\research\df\modela\results\p1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\p2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\p3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\p4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\p5c.out reset; output on; 
endif;

series2[cv1,1]~series2[cv2,1]~series2[cv3,1]~series2[cv4,1];
series2[cv5,1]~series2[cv6,1]~series2[cv7,1]~series2[cv8,1];

output off;

@---------------------------------------------------------------------------------------------------------------------------------------@
elseif stepn==5;

if iter==1; output file=c:\research\df\modela\results\t1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\t2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\t3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\t4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\t5c.out reset; output on; 
endif;

series1[cv1,1]~series1[cv2,1]~series1[cv3,1]~series1[cv4,1];
series1[cv5,1]~series1[cv6,1]~series1[cv7,1]~series1[cv8,1];

output off;

series2=sortc(series2,1);

if iter==1; output file=c:\research\df\modela\results\p1c.out reset; output on; 
elseif iter==2; output file=c:\research\df\modela\results\p2c.out reset; output on; 
elseif iter==3; output file=c:\research\df\modela\results\p3c.out reset; output on; 
elseif iter==4; output file=c:\research\df\modela\results\p4c.out reset; output on; 
elseif iter==5; output file=c:\research\df\modela\results\p5c.out reset; output on; 
endif;

series2[cv1,1]~series2[cv2,1]~series2[cv3,1]~series2[cv4,1];
series2[cv5,1]~series2[cv6,1]~series2[cv7,1]~series2[cv8,1];

output off;

@-------------------------------------------------------------------------------------------------------------------------------------@
endif; @ end of the stepn "if" @


iter=iter+1; endo;
stepn=stepn+1;endo;

et=hsec-ts;
?"stop watch:" et/100/60;
end;





